diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
index 1beacac78..13650edd3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
@@ -10,6 +10,7 @@ import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.retro.ChunkDecoratorOverworldRetro;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.retro.SurfaceGeneratorOverworldRetro;
 import net.minecraft.core.world.noise.CombinedPerlinNoise;
+import net.minecraft.core.world.noise.LegacyNoiseType;
 import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
@@ -29,13 +30,13 @@ public class ChunkGeneratorClassic
         super(world, new ChunkDecoratorOverworldRetro(world));
         long seed = world.getRandomSeed();
 
-        this.combinedA = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 0), new PerlinNoise(seed, 8, 8));
-        this.combinedB = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 16), new PerlinNoise(seed, 8, 24));
-        this.combinedC = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 32), new PerlinNoise(seed, 8, 40));
-        this.combinedD = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 48), new PerlinNoise(seed, 8, 56));
+        this.combinedA = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 0, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 8, LegacyNoiseType.ALPHA));
+        this.combinedB = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 16, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 24, LegacyNoiseType.ALPHA));
+        this.combinedC = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 32, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 40, LegacyNoiseType.ALPHA));
+        this.combinedD = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 48, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 56, LegacyNoiseType.ALPHA));
 
-        this.octavesA = new PerlinNoise(seed, 6, 64);
-        this.octavesB = new PerlinNoise(seed, 8, 70);
+        this.octavesA = new PerlinNoise(seed, 6, 64, LegacyNoiseType.ALPHA);
+        this.octavesB = new PerlinNoise(seed, 8, 70, LegacyNoiseType.ALPHA);
 
         this.sg = new SurfaceGeneratorOverworldRetro(world);
         this.cg = new CavesLargeFeature();
@@ -57,7 +58,7 @@ public class ChunkGeneratorClassic
             for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
                 final double noiseA = this.combinedA.get((chunkX * Chunk.CHUNK_SIZE_X + x) * mod, (chunkZ * Chunk.CHUNK_SIZE_Z + z) * mod) / 6.0D + -4;
                 double noiseB = this.combinedB.get((chunkX * Chunk.CHUNK_SIZE_X + x) * mod, (chunkZ * Chunk.CHUNK_SIZE_Z + z) * mod) / 5.0D + 10.0D + -4;
-                if (this.octavesA.get(chunkX * Chunk.CHUNK_SIZE_X + x, chunkZ * Chunk.CHUNK_SIZE_Z + z) / 8.0D > 0.0D) {
+                if (this.octavesA.getValue(chunkX * Chunk.CHUNK_SIZE_X + x, chunkZ * Chunk.CHUNK_SIZE_Z + z) / 8.0D > 0.0D) {
                     noiseB = noiseA;
                 }
 
@@ -86,7 +87,7 @@ public class ChunkGeneratorClassic
         // Soiling..
         for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
             for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                final int val = (int) (this.octavesB.get(chunkX * Chunk.CHUNK_SIZE_X + x, chunkZ * Chunk.CHUNK_SIZE_Z + z) / 24.0D) - 4;
+                final int val = (int) (this.octavesB.getValue(chunkX * Chunk.CHUNK_SIZE_X + x, chunkZ * Chunk.CHUNK_SIZE_Z + z) / 24.0D) - 4;
                 int newHeight;
                 final int val2 = (newHeight = newHeightMap[x + z * Chunk.CHUNK_SIZE_X] + this.world.getWorldType().getOceanY()) + val;
                 newHeightMap[x + z * Chunk.CHUNK_SIZE_X] = Math.max(newHeight, val2);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
index a7bd40a6b..b217a406e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
@@ -5,7 +5,8 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.noise.CombinedPerlinNoise;
-import net.minecraft.core.world.noise.RetroPerlinNoise;
+import net.minecraft.core.world.noise.LegacyNoiseType;
+import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public final class LevelGenerator {
@@ -44,10 +45,10 @@ public final class LevelGenerator {
             } else {
                 // Raising phase
 //                System.out.println("Raising..");
-                CombinedPerlinNoise heightNoiseGeneratorA = new CombinedPerlinNoise(new RetroPerlinNoise(seed, 8, 0), new RetroPerlinNoise(seed, 8, 8));
-                CombinedPerlinNoise heightNoiseGeneratorB = new CombinedPerlinNoise(new RetroPerlinNoise(seed, 8, 16), new RetroPerlinNoise(seed, 8, 24));
-                RetroPerlinNoise heightNoiseGeneratorSelector = new RetroPerlinNoise(seed, 6, 32);
-                RetroPerlinNoise edgeNoiseGenerator = new RetroPerlinNoise(seed, 2, 38);
+                CombinedPerlinNoise heightNoiseGeneratorA = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 0, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 8, LegacyNoiseType.ALPHA));
+                CombinedPerlinNoise heightNoiseGeneratorB = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 16, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 24, LegacyNoiseType.ALPHA));
+                PerlinNoise heightNoiseGeneratorSelector = new PerlinNoise(seed, 6, 32, LegacyNoiseType.ALPHA);
+                PerlinNoise edgeNoiseGenerator = new PerlinNoise(seed, 2, 38, LegacyNoiseType.ALPHA);
 
                 for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
                     double xDistanceFromCenter = Math.abs(((double) (x + xOffset) / ((double) this.sizeX - 1.0) - 0.5) * 2.0);
@@ -58,7 +59,7 @@ public final class LevelGenerator {
                         // Generate noise to use for height
                         double heightNoiseA = heightNoiseGeneratorA.get((float) (x + xOffset) * 1.3F, (float) (z + zOffset) * 1.3F) / 6.0 + -4.0;
                         double heightNoiseB = heightNoiseGeneratorB.get((float) (x + xOffset) * 1.3F, (float) (z + zOffset) * 1.3F) / 5.0 + 10.0 + -4.0;
-                        double heightNoiseToUse = heightNoiseGeneratorSelector.get(x + xOffset, z + zOffset) / 8.0;
+                        double heightNoiseToUse = heightNoiseGeneratorSelector.getValue(x + xOffset, z + zOffset) / 8.0;
                         if (heightNoiseToUse > 0.0) {
                             heightNoiseB = heightNoiseA;
                         }
@@ -67,7 +68,7 @@ public final class LevelGenerator {
                         if (this.worldType == IndevWorldType.ISLAND) {
                             // Use the distance value to create the "hill" effect island terrain has
                             double distanceFromCenter = Math.sqrt(xDistanceFromCenter * xDistanceFromCenter + zDistanceFromCenter * zDistanceFromCenter) * (double) 1.2F;
-                            double edgeNoise = edgeNoiseGenerator.get((float) (x + xOffset) * 0.05F, (float) (z + zOffset) * 0.05F) / 4.0 + 1.0;
+                            double edgeNoise = edgeNoiseGenerator.getValue((float) (x + xOffset) * 0.05F, (float) (z + zOffset) * 0.05F) / 4.0 + 1.0;
                             distanceFromCenter = Math.min(distanceFromCenter, edgeNoise);
                             distanceFromCenter = Math.max(distanceFromCenter,
                                 Math.max(xDistanceFromCenter, zDistanceFromCenter));
@@ -96,8 +97,8 @@ public final class LevelGenerator {
 
                 // Eroding phase
 //                System.out.println("Eroding..");
-                CombinedPerlinNoise erosionPowerNoiseGenerator = new CombinedPerlinNoise(new RetroPerlinNoise(seed, 8, 40), new RetroPerlinNoise(seed, 8, 48));
-                CombinedPerlinNoise erosionAmountNoiseGenerator = new CombinedPerlinNoise(new RetroPerlinNoise(seed, 8, 56), new RetroPerlinNoise(seed, 8, 64));
+                CombinedPerlinNoise erosionPowerNoiseGenerator = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 40, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 48, LegacyNoiseType.ALPHA));
+                CombinedPerlinNoise erosionAmountNoiseGenerator = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 56, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 64, LegacyNoiseType.ALPHA));
 
                 for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
                     for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
@@ -115,8 +116,8 @@ public final class LevelGenerator {
 
             // Soiling phase
 //            System.out.println("Soiling..");
-            RetroPerlinNoise soilNoiseGenerator = new RetroPerlinNoise(seed, 8, 72);
-            RetroPerlinNoise floatingLayerNoiseGenerator = new RetroPerlinNoise(seed, 8, 80);
+            PerlinNoise soilNoiseGenerator = new PerlinNoise(seed, 8, 72, LegacyNoiseType.ALPHA);
+            PerlinNoise floatingLayerNoiseGenerator = new PerlinNoise(seed, 8, 80, LegacyNoiseType.ALPHA);
 
             for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
                 double xDistanceFromCenter = Math.abs(((double) (x + xOffset) / ((double) this.sizeX - 1.0) - 0.5) * 2.0);
@@ -127,7 +128,7 @@ public final class LevelGenerator {
                     distanceFromCenter = distanceFromCenter * distanceFromCenter * distanceFromCenter;
 
                     // Determine the height of the soil layer
-                    int soilNoise = (int) (soilNoiseGenerator.get(x + xOffset, z + zOffset) / 24.0) - 4;
+                    int soilNoise = (int) (soilNoiseGenerator.getValue(x + xOffset, z + zOffset) / 24.0) - 4;
                     int height = heightMap[x + z * Chunk.CHUNK_SIZE_X] + waterLevel;
                     int soilHeight = height + soilNoise;
 
@@ -141,7 +142,7 @@ public final class LevelGenerator {
                     }
 
                     // Determine the minimum height of the layer (only applicable in floating island generation)
-                    double floatingLayerNoise = floatingLayerNoiseGenerator.get((double) (x + xOffset) * 2.3, (double) (z + zOffset) * 2.3) / 24.0;
+                    double floatingLayerNoise = floatingLayerNoiseGenerator.getValue((double) (x + xOffset) * 2.3, (double) (z + zOffset) * 2.3) / 24.0;
                     int floatingLayerMinY = (int) (Math.sqrt(Math.abs(floatingLayerNoise)) * Math.signum(floatingLayerNoise) * 20.0) + waterLevel;
                     floatingLayerMinY = (int) ((double) floatingLayerMinY * (1.0 - distanceFromCenter) + distanceFromCenter * (double) this.sizeY);
                     if (floatingLayerMinY > waterLevel) {
@@ -167,8 +168,8 @@ public final class LevelGenerator {
 
             // Growing phase - no idea why it's called this because it's very clearly generating beaches
 //            System.out.println("Growing..");
-            RetroPerlinNoise sandNoiseGenerator = new RetroPerlinNoise(seed, 8, 88);
-            RetroPerlinNoise gravelNoiseGenerator = new RetroPerlinNoise(seed, 8, 96);
+            PerlinNoise sandNoiseGenerator = new PerlinNoise(seed, 8, 88, LegacyNoiseType.ALPHA);
+            PerlinNoise gravelNoiseGenerator = new PerlinNoise(seed, 8, 96, LegacyNoiseType.ALPHA);
             int beachHeight = waterLevel - 1;
             if (this.worldTheme == IndevWorldTheme.PARADISE) {
                 beachHeight += 2;
@@ -176,19 +177,19 @@ public final class LevelGenerator {
 
             for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
                 for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                    boolean isSand = sandNoiseGenerator.get(x + xOffset, z + zOffset) > 8.0;
-                    boolean isGravel = gravelNoiseGenerator.get(x + xOffset, z + zOffset) > 12.0;
+                    boolean isSand = sandNoiseGenerator.getValue(x + xOffset, z + zOffset) > 8.0;
+                    boolean isGravel = gravelNoiseGenerator.getValue(x + xOffset, z + zOffset) > 12.0;
 
                     if (this.worldType == IndevWorldType.ISLAND) {
-                        isSand = sandNoiseGenerator.get(x + xOffset, z + zOffset) > -8.0;
+                        isSand = sandNoiseGenerator.getValue(x + xOffset, z + zOffset) > -8.0;
                     }
 
                     if (this.worldTheme == IndevWorldTheme.PARADISE) {
-                        isSand = sandNoiseGenerator.get(x + xOffset, z + zOffset) > -32.0;
+                        isSand = sandNoiseGenerator.getValue(x + xOffset, z + zOffset) > -32.0;
                     }
 
                     if (this.worldTheme == IndevWorldTheme.HELL || this.worldTheme == IndevWorldTheme.WOODS) {
-                        isSand = sandNoiseGenerator.get(x + xOffset, z + zOffset) > -8.0;
+                        isSand = sandNoiseGenerator.getValue(x + xOffset, z + zOffset) > -8.0;
                     }
 
                     int height = heightMap[x + z * Chunk.CHUNK_SIZE_X];
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
index 38389b6ff..afb601249 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
@@ -62,9 +62,9 @@ public class DensityGeneratorDrift
         // uses temp and humidity to alter terrain shape.
 //        double[] scaleArray = scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
 //        double[] depthArray = depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
-        double[] mainNoiseArray = this.mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
-        double[] minLimitArray = this.minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] maxLimitArray = this.maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
         int mainIndex = 0;
 //        int depthScaleIndex = 0;
         int xSizeScale = 16 / xSize;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index bf6ddec81..bbe327f77 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -42,7 +42,7 @@ public class ChunkDecoratorNether
         if (biome == Biomes.NETHER_CRYSTAL_FOREST) {
             double noiseScale = 0.5;
 
-            int density = (int) ((this.crystalDensityNoise.get(x * noiseScale, z * noiseScale) - 6D + 36D) / 6D);
+            int density = (int) ((this.crystalDensityNoise.getValue(x * noiseScale, z * noiseScale) - 6D + 36D) / 6D);
 
             for (int i = 0; i < density - 5; i++) {
                 int xf = x + rand.nextInt(16) + 8;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
index 28e430e6d..c43c0e0e9 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
@@ -147,9 +147,9 @@ public class DensityGeneratorNether
         final double upperLimitScale = 512.0;
         final double lowerLimitScale = 512.0;
 
-        double[] mainNoiseArray = this.mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
-        double[] minLimitArray = this.minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] maxLimitArray = this.maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
         int mainIndex = 0;
         double[] densityOffsetArray = new double[ySize];
         for (int dy = 0; dy < ySize; dy++) {
@@ -224,13 +224,13 @@ public class DensityGeneratorNether
 
         double ravineNoiseScale = 0.03D;
 
-        double[] scaleArray = this.scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
-        double[] depthArray = this.depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
-        double[] mainNoiseArray = this.mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
-        double[] minLimitArray = this.minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] maxLimitArray = this.maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] scaleArray = this.scaleNoise.getRegion(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = this.depthNoise.getRegion(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
 
-        double[] ravineNoise = this.ravineNoise2.getValue(null, x, z, xSize, zSize, ravineNoiseScale, ravineNoiseScale, 3.0D, 3.0D);
+        double[] ravineNoise = this.ravineNoise2.getRegion(null, x, z, xSize, zSize, ravineNoiseScale, ravineNoiseScale, 3.0D, 3.0D);
 //        double[] ravineMod = ravineNoise2.getValue(null, x, z, xSize, zSize, ravineNoiseScale, ravineNoiseScale, 0.25D, 0.6D);
 
         int mainIndex = 0;
@@ -351,12 +351,12 @@ public class DensityGeneratorNether
 
         final double noiseScale = 0.02;
 
-        double[] scaleArray = this.scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
-        double[] depthArray = this.depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
-        double[] mainNoiseArray = this.mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
-        double[] minLimitArray = this.minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] maxLimitArray = this.maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] islandNoiseArray = this.islandNoise.getValue(null, x, z, xSize, zSize, noiseScale, noiseScale, 2, 2);
+        double[] scaleArray = this.scaleNoise.getRegion(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = this.depthNoise.getRegion(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] islandNoiseArray = this.islandNoise.getRegion(null, x, z, xSize, zSize, noiseScale, noiseScale, 2, 2);
 
         int mainIndex = 0;
 
@@ -465,11 +465,11 @@ public class DensityGeneratorNether
         final double upperLimitScale = 512;
         final double lowerLimitScale = 512;
 
-        double[] scaleArray = this.scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
-        double[] depthArray = this.depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
-        double[] mainNoiseArray = this.mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
-        double[] minLimitArray = this.minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] maxLimitArray = this.maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] scaleArray = this.scaleNoise.getRegion(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = this.depthNoise.getRegion(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
         int mainIndex = 0;
 
         int depthScaleIndex = 0;
@@ -571,13 +571,13 @@ public class DensityGeneratorNether
         final double upperLimitScale = 512;
         final double lowerLimitScale = 512;
 
-        double[] scaleArray = this.scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
-        double[] depthArray = this.depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
-        double[] mainNoiseArray = this.mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
-        double[] minLimitArray = this.minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] maxLimitArray = this.maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] poolOverArray = this.poolNoiseOver.getValue(null, x, z, xSize, zSize, poolNoiseScale, poolNoiseScale, 1, 0.2);
-        double[] poolUnderArray = this.poolNoiseUnder.getValue(null, x, z, xSize, zSize, poolNoiseScale, poolNoiseScale, 0.01, 1);
+        double[] scaleArray = this.scaleNoise.getRegion(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = this.depthNoise.getRegion(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] poolOverArray = this.poolNoiseOver.getRegion(null, x, z, xSize, zSize, poolNoiseScale, poolNoiseScale, 1, 0.2);
+        double[] poolUnderArray = this.poolNoiseUnder.getRegion(null, x, z, xSize, zSize, poolNoiseScale, poolNoiseScale, 0.01, 1);
         int mainIndex = 0;
 
         int depthScaleIndex = 0;
@@ -686,11 +686,11 @@ public class DensityGeneratorNether
         final double upperLimitScale = 512;
         final double lowerLimitScale = 512;
 
-        double[] scaleArray = this.scaleNoise.get(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
-        double[] depthArray = this.depthNoise.get(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
-        double[] mainNoiseArray = this.mainNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
-        double[] minLimitArray = this.minLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] maxLimitArray = this.maxLimitNoise.get(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] scaleArray = this.scaleNoise.getRegion(null, x, z, xSize, zSize, scaleNoiseScaleX, scaleNoiseScaleZ);
+        double[] depthArray = this.depthNoise.getRegion(null, x, z, xSize, zSize, depthNoiseScaleX, depthNoiseScaleZ);
+        double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
+        double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
+        double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
         int mainIndex = 0;
 
         int depthScaleIndex = 0;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 4829802d3..945bdef32 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -40,9 +40,9 @@ public class SurfaceGeneratorNether
         Random rand = new Random((long) chunkX * 0x4F9939F508L + (long) chunkZ * 0x1EF1565BD5L);
 
         double beachScale = 0.03125D;
-        double[] sandBeachNoise = this.beachNoise.get(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale, beachScale, 1.0D);
-        double[] gravelBeachNoise = this.beachNoise.get(null, chunkX * 16, 109.0134D, chunkZ * 16, 16, 1, 16, beachScale, 1.0D, beachScale);
-        double[] soilThicknessNoise = this.soilNoise.get(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale * 2D, beachScale * 2D, beachScale * 2D);
+        double[] sandBeachNoise = this.beachNoise.getRegion(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale, beachScale, 1.0D);
+        double[] gravelBeachNoise = this.beachNoise.getRegion(null, chunkX * 16, 109.0134D, chunkZ * 16, 16, 1, 16, beachScale, 1.0D, beachScale);
+        double[] soilThicknessNoise = this.soilNoise.getRegion(null, chunkX * 16, chunkZ * 16, 0.0D, 16, 16, 1, beachScale * 2D, beachScale * 2D, beachScale * 2D);
         for (int z = 0; z < 16; z++) {
             for (int x = 0; x < 16; x++) {
                 boolean generateSandBeach = sandBeachNoise[z + x * 16] + rand.nextDouble() * 0.2D > 0.0D;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index ce8e73a70..559c013c1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -73,7 +73,7 @@ public class TerrainGeneratorNether
         if (this.lastChunkX != chunk.pos.x || this.lastChunkZ != chunk.pos.z) {
             this.lastChunkX = chunk.pos.x;
             this.lastChunkZ = chunk.pos.z;
-            this.noise.get(this.cache, chunk.pos.x * Chunk.CHUNK_SIZE_X, 0, chunk.pos.z * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, 0.2, 0.2, 0.2);
+            this.noise.getRegion(this.cache, chunk.pos.x * Chunk.CHUNK_SIZE_X, 0, chunk.pos.z * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y, Chunk.CHUNK_SIZE_Z, 0.2, 0.2, 0.2);
 
             float avg = 0;
             for (int i = 0; i < this.cache.length; i++) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 16fbdd278..8d2144ccd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -13,13 +13,13 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.noise.PerlinNoise;
 import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.overworld.BiomeOutback;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
-import net.minecraft.core.world.noise.PerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -250,7 +250,7 @@ public class ChunkDecoratorOverworld
 
 
         double d = 0.5D;
-        int k4 = (int) ((this.treeDensityNoise.get((double) x * d, (double) z * d) / 8D + rand.nextDouble() * 4D + 4D) / 3D);
+        int k4 = (int) ((this.treeDensityNoise.getValue((double) x * d, (double) z * d) / 8D + rand.nextDouble() * 4D + 4D) / 3D);
         int treeDensity = 0;
         if (rand.nextInt(10) == 0) {
             treeDensity++;
